local function chain_fun(s,v)
  if #s == 0
    return
  end

  local iter = s[1]
  local k,v = next(iter, v)

  while k==nil and #s > 0 do
    table.remove(s, 1)
    k,v = next(iter, v)
  end

  return k,v
end

-- chains all of the iterators passed as argument
function chain(...)
  return chain_fun, ..., nil
end